/*      Nume:    Ionescu Florin-Eugen
        Grupa:   333CB
        Proiect: LED Cube
*/

#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>

#define NUM_LAYERS 4
#define NUM_LEDS_PER_LAYER 16

#define DELAY 500



void ON_ledAt (int layerID, int ledID)
{
	switch (layerID)
	{
		case 0:
			PORTD |= (1 << 3);
			break;
			
		case 1:
			PORTD |= (1 << 4);
			break;
			
		case 2:
			PORTD |= (1 << 5);
			break;
			
		case 3:
			PORTD |= (1 << 6);
			break;

	}
	
	if (ledID > 0 && ledID < 8)
		PORTC |= (1 << ledID);
	if (ledID > 7 && ledID < 16)
		PORTA |= (1 << (ledID - 8));
}

void OFF_ledAt (int layerID, int ledID)
{
	switch (layerID)
	{
		case 0:
			PORTD &=~ (1 << 3);
			break;
			
		case 1:
			PORTD &=~ (1 << 4);
			break;
			
		case 2:
			PORTD &=~ (1 << 5);
			break;
			
		case 3:
			PORTD &=~ (1 << 6);
			break;
			
		default:
			break;
	}
	
	if (ledID > 0 && ledID < 8)
		PORTC &=~ (1 << ledID);
	if (ledID > 7 && ledID < 16)
		PORTA &=~ (1 << (ledID - 8));
}


void pattern1 ()
{
	int i, j, prev;
	
	for (j = 0; j < NUM_LAYERS; j ++)
	{		
		for (i = 0; i < NUM_LEDS_PER_LAYER; i ++)
			ON_ledAt (j, i);
			
		_delay_ms (DELAY);
			
		if (j == 0) prev = NUM_LAYERS - 1;
		else prev = j - 1;
		
		for (i = 0; i < NUM_LEDS_PER_LAYER; i ++)
			OFF_ledAt (j, i);
				
		_delay_ms (DELAY);
	}		
}

void pattern2 ()
{
	int i, j;
	
	for (i = 0; i < NUM_LAYERS; i ++)
	{
		PORTD |= (1 << (i + 3));
		
		for (j = 0; j < NUM_LEDS_PER_LAYER / 2; j ++)
		{
			PORTA |= (1 << j);
			
			_delay_ms (DELAY);
		}
		
		for (j = 0; j < NUM_LEDS_PER_LAYER / 2; j ++)
		{
			PORTC |= (1 << j);
			
			_delay_ms (DELAY);
		}
	}
	
	_delay_ms (DELAY);
	
	for (i = 0; i < NUM_LAYERS; i ++)
	{
		for (j = 0; j < NUM_LEDS_PER_LAYER / 2; j ++)
		{
			PORTA &=~ (1 << j);
			
			_delay_ms (DELAY);
		}
		
		for (j = 0; j < NUM_LEDS_PER_LAYER / 2; j ++)
		{
			PORTC &=~ (1 << j);
			
			_delay_ms (DELAY);
		}
		
		PORTD &=~ (1 << (i + 3));
	}
}



void pattern3 ()
{
	int i, j;
	
	for (j = 0; j < NUM_LAYERS; j ++)
		for (i = 0; i < NUM_LEDS_PER_LAYER; i ++)
			ON_ledAt (j, i);
	
	_delay_ms (DELAY * 6);
	
	for (j = 0; j < NUM_LAYERS; j ++)
		for (i = 0; i < NUM_LEDS_PER_LAYER; i ++)
			OFF_ledAt (j, i);
	
	_delay_ms (DELAY * 6);
}

void pattern4 ()
{
	int i, j, prev, next;
	
	for (j = 0; j < NUM_LAYERS; j ++)
	{
		if (j == NUM_LAYERS - 1) next = 0;
		else next = j + 1;
		
		for (i = 0; i < NUM_LEDS_PER_LAYER; i ++)
		{
			ON_ledAt (j, i);
			ON_ledAt (next, i);
		}
		
		_delay_ms (DELAY * 4);
		
		if (j == 0) prev = NUM_LAYERS - 1;
		else prev = j - 1;
		
		for (i = 0; i < NUM_LEDS_PER_LAYER; i ++)
			OFF_ledAt (j, i);
	}
}


int main() {
    
    int i;
    
    DDRA = 0xFF;
    DDRC = 0xFF;
    DDRD = 0xFF;
    
    while(1) {
             
			 for (i = 0; i < 2; i++) {

            PORTD = 0b10000000;
            PORTA = 0b11111111;
            PORTC = 0b11111111;

            _delay_ms(3000);

            PORTD = 0b01000000;
            PORTA = 0b11111111;
            PORTC = 0b11111111;

            _delay_ms(3000);

            PORTD = 0b00100000;
            PORTA = 0b11111111;
            PORTC = 0b11111111;

            _delay_ms(3000);

            PORTD = 0b00010000;
            PORTA = 0b11111111;
            PORTC = 0b11111111;

            _delay_ms(3000);
        }
			 
             for (i = 0; i < 4; i++) {
                 
                 PORTA = 0b11111111;
                 PORTC = 0b11111111;
                 PORTD = 0b00010000;
                 
                 _delay_ms(2000);
                 
                 PORTA = 0b11111111;
                 PORTC = 0b11111111;
                 PORTD = 0b00100000;
                 
                 _delay_ms(2000);
                 
                 PORTA = 0b11111111;
                 PORTC = 0b11111111;
                 PORTD = 0b10000000;
                 
                 _delay_ms(2000);
                 
                 PORTA = 0b11111111;
                 PORTC = 0b11111111;
                 PORTD = 0b01000000;
                 
                 _delay_ms(2000);
                 
                 PORTA = 0b11111111;
                 PORTC = 0b11111111;
                 PORTD = 0b10000000;
                 
                 _delay_ms(2000);
                 
                 PORTA = 0b11111111;
                 PORTC = 0b11111111;
                 PORTD = 0b00100000;
                 
                 _delay_ms(2000);
        }
		
		for (i = 0; i < 15; i++) {
		pattern1();
		//_delay_ms(2000);
		}
		
		for (i = 0; i < 4; i++) {
		pattern2();
		//_delay_ms(2000);
		}
		
		for (i = 0; i < 5; i++) {
		pattern3();
		//_delay_ms(2000);
		}
		
		for (i = 0; i < 5; i++) {
		pattern4();
		//_delay_ms(2000);
		}
		
		
		/*for (i = 0; i < 6; i++) {
            
				PORTA = 0;
				PORTC = 0b00000001;
				PORTD = 0b00010000;
				
				_delay_ms(2100);
				
				PORTA = 0;
				PORTC = 0b00000001;
				PORTD = 0b00100000;
				
				_delay_ms(2400);
				
				PORTA = 0;
				PORTC = 0b00000001;
				PORTD = 0b10000000;
				
				_delay_ms(3000);
				
				PORTA = 0;
				PORTC = 0b00000001;
				PORTD = 0b01000000;
				
				_delay_ms(3000);
				
				PORTA = 0b01010000;
				PORTC = 0b00101001;
				PORTD = 0b01000000;
				
				_delay_ms(3000);
				
				PORTA = 0b01010000;
				PORTC = 0b00101000;
				PORTD = 0b10000000;
				
				_delay_ms(2400);
				
				PORTA = 0b01010000;
				PORTC = 0b00101000;
				PORTD = 0b00100000;
				
				_delay_ms(2100);
				
		}*/
		
		
	}
	
}
